/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parserparse
#define yylex           parserlex
#define yyerror         parsererror
#define yydebug         parserdebug
#define yynerrs         parsernerrs

#define yylval          parserlval
#define yychar          parserchar

/* Copy the first part of user declarations.  */
#line 29 "../src/parser.y" /* yacc.c:339  */


#include <sys/types.h>
#include <sys/stat.h>
#ifndef _MSC_VER
#include <unistd.h>
#endif

#include "typedefs.h"
#include "module.h"
#include "expression.h"
#include "value.h"
#include "function.h"
#include "printutils.h"
#include <sstream>
#include <boost/foreach.hpp>
#include <boost/filesystem.hpp>

namespace fs = boost::filesystem;
#define foreach BOOST_FOREACH

#include "boosty.h"

int parser_error_pos = -1;

int parserlex(void);
void yyerror(char const *s);

int lexerget_lineno(void);
int lexerlex_destroy(void);
int lexerlex(void);

std::stack<LocalScope *> scope_stack;
FileModule *rootmodule;

extern void lexerdestroy();
extern FILE *lexerin;
extern const char *parser_input_buffer;
const char *parser_input_buffer;
std::string parser_source_path;


#line 117 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser_yacc.h".  */
#ifndef YY_PARSER_HOME_DON_BUILDER_OPENSCAD_MINGW64_TESTS_BUILD_PARSER_YACC_H_INCLUDED
# define YY_PARSER_HOME_DON_BUILDER_OPENSCAD_MINGW64_TESTS_BUILD_PARSER_YACC_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int parserdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ERROR = 258,
    TOK_MODULE = 259,
    TOK_FUNCTION = 260,
    TOK_IF = 261,
    TOK_ELSE = 262,
    TOK_FOR = 263,
    TOK_LET = 264,
    TOK_ID = 265,
    TOK_STRING = 266,
    TOK_USE = 267,
    TOK_NUMBER = 268,
    TOK_TRUE = 269,
    TOK_FALSE = 270,
    TOK_UNDEF = 271,
    LE = 272,
    GE = 273,
    EQ = 274,
    NE = 275,
    AND = 276,
    OR = 277,
    LET = 278
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 72 "../src/parser.y" /* yacc.c:355  */

  char *text;
  double number;
  class Value *value;
  class Expression *expr;
  class ModuleInstantiation *inst;
  class IfElseModuleInstantiation *ifelse;
  Assignment *arg;
  AssignmentList *args;

#line 192 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE parserlval;

int parserparse (void);

#endif /* !YY_PARSER_HOME_DON_BUILDER_OPENSCAD_MINGW64_TESTS_BUILD_PARSER_YACC_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 207 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  33
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   554

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  45
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  27
/* YYNRULES -- Number of rules.  */
#define YYNRULES  88
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  182

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   278

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    28,     2,    43,     2,    33,     2,     2,
      40,    41,    31,    29,    44,    30,    36,    32,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    25,    37,
      26,    42,    27,    24,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    34,     2,    35,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    38,     2,    39,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   139,   139,   141,   140,   143,   147,   148,   149,   153,
     155,   154,   168,   167,   179,   181,   185,   203,   208,   213,
     218,   224,   223,   233,   240,   245,   244,   257,   256,   270,
     272,   276,   277,   278,   293,   294,   298,   309,   313,   317,
     321,   328,   334,   339,   343,   351,   358,   366,   372,   376,
     380,   384,   388,   392,   396,   400,   404,   408,   412,   416,
     420,   424,   428,   432,   436,   440,   444,   448,   456,   460,
     474,   481,   494,   502,   503,   507,   508,   512,   516,   525,
     528,   534,   543,   548,   557,   560,   566,   575,   579
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ERROR", "TOK_MODULE",
  "TOK_FUNCTION", "TOK_IF", "TOK_ELSE", "TOK_FOR", "TOK_LET", "TOK_ID",
  "TOK_STRING", "TOK_USE", "TOK_NUMBER", "TOK_TRUE", "TOK_FALSE",
  "TOK_UNDEF", "LE", "GE", "EQ", "NE", "AND", "OR", "LET", "'?'", "':'",
  "'<'", "'>'", "'!'", "'+'", "'-'", "'*'", "'/'", "'%'", "'['", "']'",
  "'.'", "';'", "'{'", "'}'", "'('", "')'", "'='", "'#'", "','", "$accept",
  "input", "$@1", "statement", "$@2", "$@3", "inner_input", "assignment",
  "module_instantiation", "@4", "ifelse_statement", "$@5", "if_statement",
  "@6", "child_statements", "child_statement", "module_id",
  "single_module_instantiation", "expr", "list_comprehension_elements",
  "list_comprehension_elements_or_expr", "optional_commas", "vector_expr",
  "arguments_decl", "argument_decl", "arguments_call", "argument_call", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    63,    58,    60,    62,    33,    43,
      45,    42,    47,    37,    91,    93,    46,    59,   123,   125,
      40,    41,    61,    35,    44
};
# endif

#define YYPACT_NINF -58

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-58)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      78,     0,     6,    -3,   -58,   -12,   -58,    12,    12,    12,
     -58,   123,    12,    36,    78,   -58,   -58,   -58,    31,     2,
     -58,     4,    19,   230,   230,    78,   -58,   -58,   -58,   -58,
     123,    13,   -58,   -58,   -58,   -58,   258,   186,    50,    50,
      21,    38,   -58,   -58,   -58,   -58,   -58,   230,   230,   230,
     159,   230,   282,   357,   -58,   -58,   -58,   186,   -31,   478,
     -20,   -58,   -58,   -58,   -58,   -58,    37,    43,   -58,    43,
     258,   258,    15,    15,    15,    53,    54,    70,    68,   398,
      79,    82,    69,   307,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   108,
     -58,   -58,   -58,   230,   -58,    68,   173,   230,    68,    83,
      84,   -10,    -9,   230,   258,   258,   -58,   230,   -58,   -58,
      68,    85,   -58,   246,   246,    67,    67,   518,   498,   418,
     246,   246,    15,    15,   -19,   -19,   -19,   438,   -58,   186,
     478,   258,   -58,   -58,   478,    50,   -58,    77,   230,   -58,
     332,    63,    64,   378,   230,   -58,   230,   -58,   -58,   -58,
     -58,   123,   230,   478,   222,   222,   222,   230,   -58,   478,
     478,   -58,   478,   478,   -58,   -58,   -58,   -58,   458,    86,
     -58,   -58
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     0,     0,    35,    34,     3,     0,     0,     0,
       6,    14,     0,     0,     2,     9,     8,    23,    24,     0,
      21,     0,     0,     0,     0,     2,    34,    17,    20,    19,
      14,     0,    18,     1,     5,    25,    84,     0,    79,    79,
       0,    40,    42,    43,    37,    38,    39,     0,     0,     0,
      76,     0,     0,     0,     4,    15,     7,     0,    40,    87,
       0,    85,    31,    29,    33,    22,    82,    76,    80,    76,
      84,    84,    65,    63,    64,     0,     0,     0,    76,    77,
       0,     0,    76,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      27,    16,    26,     0,    36,    76,     0,     0,    76,     0,
       0,     0,     0,     0,    84,    84,    75,     0,    47,    48,
      76,     0,    66,    56,    59,    57,    58,    61,    62,     0,
      55,    60,    53,    54,    50,    51,    52,     0,    41,     0,
      88,     0,    32,    30,    83,    75,    10,     0,     0,    69,
       0,     0,     0,     0,    75,    49,     0,    68,    28,    86,
      81,     0,     0,    44,     0,     0,     0,     0,    45,    78,
      67,    11,    12,    74,    73,    72,    71,    70,     0,     0,
      46,    13
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -58,    -2,   -58,   -11,   -58,   -58,   100,   -58,    -4,   -58,
     -58,   -58,   -58,   -58,   -58,   -50,   -58,   -58,   -22,   -44,
     -29,   -28,   -58,    98,    -7,   -57,     5
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    13,    25,    14,   161,   179,    31,    15,    16,    37,
      17,    57,    18,   139,   106,    65,    19,    20,    59,   174,
     175,    81,    82,    67,    68,    60,    61
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      30,    52,    53,    27,    28,    29,    80,   102,    32,    71,
      21,   103,    34,   111,   112,    98,    22,    99,     3,    30,
       4,   104,    26,    54,   105,    72,    73,    74,    79,    83,
      24,   148,   149,    64,   105,   105,    33,    23,    35,   109,
       7,   110,    36,     8,    38,     9,    95,    96,    97,    98,
     116,    99,    56,    64,   121,    12,   143,   151,   152,    39,
      66,    70,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   141,    71,   107,
     145,   140,     1,     2,     3,   144,     4,   108,     5,   158,
       6,   150,   154,   113,   114,   153,    93,    94,    95,    96,
      97,    98,    64,    99,   165,   166,     7,   105,   105,     8,
     115,     9,    78,   120,   118,    10,    11,   119,   138,   162,
     155,    12,   177,   181,   146,   147,   163,     1,     2,     3,
      55,     4,   169,     5,   170,    64,   176,    69,   160,     0,
     172,     0,   173,   173,   163,   178,   159,     0,     0,     0,
     171,     7,     0,     0,     8,     0,     9,     0,     0,     0,
      10,    11,     0,     0,     0,    75,    12,    76,    77,    41,
      42,     0,    43,    44,    45,    46,     0,     0,     0,     3,
       0,     4,     0,    26,     0,     0,     0,    47,    48,    49,
       0,     0,     3,    50,     4,     0,    26,     0,     0,    51,
       0,     7,     0,    78,     8,     0,     9,     0,     0,     0,
      62,    63,   142,     0,     7,     0,    12,     8,     0,     9,
       0,     0,     0,    62,    63,     0,     0,     0,    75,    12,
      76,    77,    41,    42,     0,    43,    44,    45,    46,    40,
      41,    42,     0,    43,    44,    45,    46,     0,     0,     0,
      47,    48,    49,     0,     0,     0,    50,     0,    47,    48,
      49,     0,    51,     0,    50,    86,    87,    40,    58,    42,
      51,    43,    44,    45,    46,    93,    94,    95,    96,    97,
      98,     0,    99,     0,     0,     0,    47,    48,    49,     0,
       0,     0,    50,     0,     0,     0,     0,     0,    51,    84,
      85,    86,    87,    88,    89,     0,    90,     0,    91,    92,
       0,    93,    94,    95,    96,    97,    98,     0,    99,     0,
       0,     0,     0,   100,    84,    85,    86,    87,    88,    89,
       0,    90,     0,    91,    92,     0,    93,    94,    95,    96,
      97,    98,     0,    99,     0,     0,     0,     0,   122,    84,
      85,    86,    87,    88,    89,     0,    90,     0,    91,    92,
       0,    93,    94,    95,    96,    97,    98,     0,    99,     0,
       0,     0,     0,   164,    84,    85,    86,    87,    88,    89,
       0,    90,     0,    91,    92,     0,    93,    94,    95,    96,
      97,    98,     0,    99,   101,    84,    85,    86,    87,    88,
      89,     0,    90,   167,    91,    92,     0,    93,    94,    95,
      96,    97,    98,   168,    99,    84,    85,    86,    87,    88,
      89,     0,    90,   117,    91,    92,     0,    93,    94,    95,
      96,    97,    98,     0,    99,    84,    85,    86,    87,    88,
      89,     0,    90,   156,    91,    92,     0,    93,    94,    95,
      96,    97,    98,     0,    99,    84,    85,    86,    87,    88,
      89,     0,    90,     0,    91,    92,     0,    93,    94,    95,
      96,    97,    98,   157,    99,    84,    85,    86,    87,    88,
      89,     0,    90,     0,    91,    92,     0,    93,    94,    95,
      96,    97,    98,   180,    99,    84,    85,    86,    87,    88,
      89,     0,    90,     0,    91,    92,     0,    93,    94,    95,
      96,    97,    98,     0,    99,    84,    85,    86,    87,    88,
       0,     0,     0,     0,    91,    92,     0,    93,    94,    95,
      96,    97,    98,     0,    99,    84,    85,    86,    87,     0,
       0,     0,     0,     0,    91,    92,     0,    93,    94,    95,
      96,    97,    98,     0,    99
};

static const yytype_int16 yycheck[] =
{
      11,    23,    24,     7,     8,     9,    50,    57,    12,    40,
      10,    42,    14,    70,    71,    34,    10,    36,     6,    30,
       8,    41,    10,    25,    44,    47,    48,    49,    50,    51,
      42,    41,    41,    37,    44,    44,     0,    40,     7,    67,
      28,    69,    40,    31,    40,    33,    31,    32,    33,    34,
      78,    36,    39,    57,    82,    43,   106,   114,   115,    40,
      10,    40,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,   105,    40,    42,
     108,   103,     4,     5,     6,   107,     8,    44,    10,   139,
      12,   113,   120,    40,    40,   117,    29,    30,    31,    32,
      33,    34,   106,    36,    41,    41,    28,    44,    44,    31,
      40,    33,    44,    44,    35,    37,    38,    35,    10,    42,
      35,    43,   166,    37,    41,    41,   148,     4,     5,     6,
      30,     8,   154,    10,   156,   139,   165,    39,   145,    -1,
     162,    -1,   164,   165,   166,   167,   141,    -1,    -1,    -1,
     161,    28,    -1,    -1,    31,    -1,    33,    -1,    -1,    -1,
      37,    38,    -1,    -1,    -1,     6,    43,     8,     9,    10,
      11,    -1,    13,    14,    15,    16,    -1,    -1,    -1,     6,
      -1,     8,    -1,    10,    -1,    -1,    -1,    28,    29,    30,
      -1,    -1,     6,    34,     8,    -1,    10,    -1,    -1,    40,
      -1,    28,    -1,    44,    31,    -1,    33,    -1,    -1,    -1,
      37,    38,    39,    -1,    28,    -1,    43,    31,    -1,    33,
      -1,    -1,    -1,    37,    38,    -1,    -1,    -1,     6,    43,
       8,     9,    10,    11,    -1,    13,    14,    15,    16,     9,
      10,    11,    -1,    13,    14,    15,    16,    -1,    -1,    -1,
      28,    29,    30,    -1,    -1,    -1,    34,    -1,    28,    29,
      30,    -1,    40,    -1,    34,    19,    20,     9,    10,    11,
      40,    13,    14,    15,    16,    29,    30,    31,    32,    33,
      34,    -1,    36,    -1,    -1,    -1,    28,    29,    30,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    40,    17,
      18,    19,    20,    21,    22,    -1,    24,    -1,    26,    27,
      -1,    29,    30,    31,    32,    33,    34,    -1,    36,    -1,
      -1,    -1,    -1,    41,    17,    18,    19,    20,    21,    22,
      -1,    24,    -1,    26,    27,    -1,    29,    30,    31,    32,
      33,    34,    -1,    36,    -1,    -1,    -1,    -1,    41,    17,
      18,    19,    20,    21,    22,    -1,    24,    -1,    26,    27,
      -1,    29,    30,    31,    32,    33,    34,    -1,    36,    -1,
      -1,    -1,    -1,    41,    17,    18,    19,    20,    21,    22,
      -1,    24,    -1,    26,    27,    -1,    29,    30,    31,    32,
      33,    34,    -1,    36,    37,    17,    18,    19,    20,    21,
      22,    -1,    24,    25,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    35,    36,    17,    18,    19,    20,    21,
      22,    -1,    24,    25,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    -1,    36,    17,    18,    19,    20,    21,
      22,    -1,    24,    25,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    -1,    36,    17,    18,    19,    20,    21,
      22,    -1,    24,    -1,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    35,    36,    17,    18,    19,    20,    21,
      22,    -1,    24,    -1,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    35,    36,    17,    18,    19,    20,    21,
      22,    -1,    24,    -1,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    -1,    36,    17,    18,    19,    20,    21,
      -1,    -1,    -1,    -1,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    -1,    36,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    -1,    26,    27,    -1,    29,    30,    31,
      32,    33,    34,    -1,    36
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     4,     5,     6,     8,    10,    12,    28,    31,    33,
      37,    38,    43,    46,    48,    52,    53,    55,    57,    61,
      62,    10,    10,    40,    42,    47,    10,    53,    53,    53,
      48,    51,    53,     0,    46,     7,    40,    54,    40,    40,
       9,    10,    11,    13,    14,    15,    16,    28,    29,    30,
      34,    40,    63,    63,    46,    51,    39,    56,    10,    63,
      70,    71,    37,    38,    53,    60,    10,    68,    69,    68,
      40,    40,    63,    63,    63,     6,     8,     9,    44,    63,
      64,    66,    67,    63,    17,    18,    19,    20,    21,    22,
      24,    26,    27,    29,    30,    31,    32,    33,    34,    36,
      41,    37,    60,    42,    41,    44,    59,    42,    44,    66,
      66,    70,    70,    40,    40,    40,    66,    25,    35,    35,
      44,    66,    41,    63,    63,    63,    63,    63,    63,    63,
      63,    63,    63,    63,    63,    63,    63,    63,    10,    58,
      63,    66,    39,    60,    63,    66,    41,    41,    41,    41,
      63,    70,    70,    63,    66,    35,    25,    35,    60,    71,
      69,    49,    42,    63,    41,    41,    41,    25,    35,    63,
      63,    48,    63,    63,    64,    65,    65,    64,    63,    50,
      35,    37
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    45,    46,    47,    46,    46,    48,    48,    48,    48,
      49,    48,    50,    48,    51,    51,    52,    53,    53,    53,
      53,    54,    53,    53,    55,    56,    55,    58,    57,    59,
      59,    60,    60,    60,    61,    61,    62,    63,    63,    63,
      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
      64,    64,    64,    65,    65,    66,    66,    67,    67,    68,
      68,    68,    69,    69,    70,    70,    70,    71,    71
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     0,     3,     2,     1,     3,     1,     1,
       0,     8,     0,    10,     0,     2,     4,     2,     2,     2,
       2,     0,     3,     1,     1,     0,     4,     0,     6,     0,
       2,     1,     3,     1,     1,     1,     4,     1,     1,     1,
       1,     3,     1,     1,     5,     5,     7,     3,     3,     4,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     2,     3,     5,     4,     4,
       5,     5,     5,     1,     1,     2,     0,     1,     4,     0,
       1,     4,     1,     3,     0,     1,     4,     1,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 141 "../src/parser.y" /* yacc.c:1646  */
    { rootmodule->registerUse(std::string((yyvsp[0].text))); }
#line 1480 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 8:
#line 150 "../src/parser.y" /* yacc.c:1646  */
    {
                if ((yyvsp[0].inst)) scope_stack.top()->addChild((yyvsp[0].inst));
            }
#line 1488 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 10:
#line 155 "../src/parser.y" /* yacc.c:1646  */
    {
                Module *newmodule = new Module();
                newmodule->definition_arguments = *(yyvsp[-2].args);
                scope_stack.top()->modules[(yyvsp[-4].text)] = newmodule;
                scope_stack.push(&newmodule->scope);
                free((yyvsp[-4].text));
                delete (yyvsp[-2].args);
            }
#line 1501 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 11:
#line 164 "../src/parser.y" /* yacc.c:1646  */
    {
                scope_stack.pop();
            }
#line 1509 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 12:
#line 168 "../src/parser.y" /* yacc.c:1646  */
    {
                Function *func = new Function();
                func->definition_arguments = *(yyvsp[-4].args);
                func->expr = (yyvsp[0].expr);
                scope_stack.top()->functions[(yyvsp[-6].text)] = func;
                free((yyvsp[-6].text));
                delete (yyvsp[-4].args);
            }
#line 1522 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 16:
#line 186 "../src/parser.y" /* yacc.c:1646  */
    {
                bool found = false;
                foreach (Assignment& iter, scope_stack.top()->assignments) {
                    if (iter.first == (yyvsp[-3].text)) {
                        iter.second = boost::shared_ptr<Expression>((yyvsp[-1].expr));
                        found = true;
                        break;
                    }
                }
                if (!found) {
                    scope_stack.top()->assignments.push_back(Assignment((yyvsp[-3].text), boost::shared_ptr<Expression>((yyvsp[-1].expr))));
                }
                free((yyvsp[-3].text));
            }
#line 1541 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 17:
#line 204 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_root = true;
            }
#line 1550 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 18:
#line 209 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_highlight = true;
            }
#line 1559 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 19:
#line 214 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_background = true;
            }
#line 1568 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 20:
#line 219 "../src/parser.y" /* yacc.c:1646  */
    {
                delete (yyvsp[0].inst);
                (yyval.inst) = NULL;
            }
#line 1577 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 21:
#line 224 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = (yyvsp[0].inst);
                scope_stack.push(&(yyvsp[0].inst)->scope);
            }
#line 1586 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 22:
#line 229 "../src/parser.y" /* yacc.c:1646  */
    {
                scope_stack.pop();
                (yyval.inst) = (yyvsp[-1].inst);
            }
#line 1595 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 23:
#line 234 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = (yyvsp[0].ifelse);
            }
#line 1603 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 24:
#line 241 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.ifelse) = (yyvsp[0].ifelse);
            }
#line 1611 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 25:
#line 245 "../src/parser.y" /* yacc.c:1646  */
    {
                scope_stack.push(&(yyvsp[-1].ifelse)->else_scope);
            }
#line 1619 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 26:
#line 249 "../src/parser.y" /* yacc.c:1646  */
    {
                scope_stack.pop();
                (yyval.ifelse) = (yyvsp[-3].ifelse);
            }
#line 1628 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 27:
#line 257 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.ifelse) = new IfElseModuleInstantiation();
                (yyval.ifelse)->arguments.push_back(Assignment("", boost::shared_ptr<Expression>((yyvsp[-1].expr))));
                (yyval.ifelse)->setPath(parser_source_path);
                scope_stack.push(&(yyval.ifelse)->scope);
            }
#line 1639 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 28:
#line 264 "../src/parser.y" /* yacc.c:1646  */
    {
                scope_stack.pop();
                (yyval.ifelse) = (yyvsp[-1].ifelse);
            }
#line 1648 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 33:
#line 279 "../src/parser.y" /* yacc.c:1646  */
    {
                if ((yyvsp[0].inst)) scope_stack.top()->addChild((yyvsp[0].inst));
            }
#line 1656 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 34:
#line 293 "../src/parser.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 1662 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 35:
#line 294 "../src/parser.y" /* yacc.c:1646  */
    { (yyval.text) = strdup("for"); }
#line 1668 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 36:
#line 299 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = new ModuleInstantiation((yyvsp[-3].text));
                (yyval.inst)->arguments = *(yyvsp[-1].args);
                (yyval.inst)->setPath(parser_source_path);
                free((yyvsp[-3].text));
                delete (yyvsp[-1].args);
            }
#line 1680 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 37:
#line 310 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression(Value(true));
            }
#line 1688 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 38:
#line 314 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression(Value(false));
            }
#line 1696 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 39:
#line 318 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression(Value::undefined);
            }
#line 1704 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 40:
#line 322 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression();
                (yyval.expr)->type = "L";
                (yyval.expr)->var_name = (yyvsp[0].text);
                free((yyvsp[0].text));
            }
#line 1715 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 41:
#line 329 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("N", (yyvsp[-2].expr));
                (yyval.expr)->var_name = (yyvsp[0].text);
                free((yyvsp[0].text));
            }
#line 1725 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 42:
#line 335 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression(Value(std::string((yyvsp[0].text))));
                free((yyvsp[0].text));
            }
#line 1734 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 43:
#line 340 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression(Value((yyvsp[0].number)));
            }
#line 1742 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 44:
#line 344 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression();
                (yyval.expr)->type = "l";
                (yyval.expr)->call_arguments = *(yyvsp[-2].args);
                delete (yyvsp[-2].args);
                (yyval.expr)->children.push_back((yyvsp[0].expr));
            }
#line 1754 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 45:
#line 352 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression();
                (yyval.expr)->type = "R";
                (yyval.expr)->children.push_back((yyvsp[-3].expr));
                (yyval.expr)->children.push_back((yyvsp[-1].expr));
            }
#line 1765 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 46:
#line 359 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression();
                (yyval.expr)->type = "R";
                (yyval.expr)->children.push_back((yyvsp[-5].expr));
                (yyval.expr)->children.push_back((yyvsp[-3].expr));
                (yyval.expr)->children.push_back((yyvsp[-1].expr));
            }
#line 1777 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 47:
#line 367 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression();
                (yyval.expr)->type = "i";
                (yyval.expr)->children.push_back((yyvsp[-1].expr));
            }
#line 1787 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 48:
#line 373 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression(Value(Value::VectorType()));
            }
#line 1795 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 49:
#line 377 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = (yyvsp[-2].expr);
            }
#line 1803 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 50:
#line 381 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("*", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1811 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 51:
#line 385 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("/", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1819 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 52:
#line 389 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("%", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1827 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 53:
#line 393 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("+", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1835 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 54:
#line 397 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("-", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1843 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 55:
#line 401 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("<", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1851 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 56:
#line 405 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("<=", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1859 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 57:
#line 409 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("==", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1867 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 58:
#line 413 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("!=", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1875 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 59:
#line 417 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression(">=", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1883 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 60:
#line 421 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression(">", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1891 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 61:
#line 425 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("&&", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1899 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 62:
#line 429 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("||", (yyvsp[-2].expr), (yyvsp[0].expr));
            }
#line 1907 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 63:
#line 433 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = (yyvsp[0].expr);
            }
#line 1915 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 64:
#line 437 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("I", (yyvsp[0].expr));
            }
#line 1923 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 65:
#line 441 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("!", (yyvsp[0].expr));
            }
#line 1931 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 66:
#line 445 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = (yyvsp[-1].expr);
            }
#line 1939 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 67:
#line 449 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression();
                (yyval.expr)->type = "?:";
                (yyval.expr)->children.push_back((yyvsp[-4].expr));
                (yyval.expr)->children.push_back((yyvsp[-2].expr));
                (yyval.expr)->children.push_back((yyvsp[0].expr));
            }
#line 1951 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 68:
#line 457 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("[]", (yyvsp[-3].expr), (yyvsp[-1].expr));
            }
#line 1959 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 69:
#line 461 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression();
                (yyval.expr)->type = "F";
                (yyval.expr)->call_funcname = (yyvsp[-3].text);
                (yyval.expr)->call_arguments = *(yyvsp[-1].args);
                free((yyvsp[-3].text));
                delete (yyvsp[-1].args);
            }
#line 1972 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 70:
#line 475 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("c", (yyvsp[0].expr));
                (yyval.expr)->call_funcname = "let";
                (yyval.expr)->call_arguments = *(yyvsp[-2].args);
                delete (yyvsp[-2].args);
            }
#line 1983 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 71:
#line 482 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = (yyvsp[0].expr);

                /* transform for(i=...,j=...) -> for(i=...) for(j=...) */
                for (int i = (yyvsp[-2].args)->size()-1; i >= 0; i--) {
                    Expression *e = new Expression("c", (yyval.expr));
                    e->call_funcname = "for";
                    e->call_arguments.push_back((*(yyvsp[-2].args))[i]);
                    (yyval.expr) = e;
                }
                delete (yyvsp[-2].args);
            }
#line 2000 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 72:
#line 495 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("c", (yyvsp[-2].expr), (yyvsp[0].expr));
                (yyval.expr)->call_funcname = "if";
            }
#line 2009 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 77:
#line 513 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = new Expression("V", (yyvsp[0].expr));
            }
#line 2017 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 78:
#line 517 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = (yyvsp[-3].expr);
                (yyval.expr)->children.push_back((yyvsp[0].expr));
            }
#line 2026 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 79:
#line 525 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = new AssignmentList();
            }
#line 2034 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 80:
#line 529 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = new AssignmentList();
                (yyval.args)->push_back(*(yyvsp[0].arg));
                delete (yyvsp[0].arg);
            }
#line 2044 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 81:
#line 535 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = (yyvsp[-3].args);
                (yyval.args)->push_back(*(yyvsp[0].arg));
                delete (yyvsp[0].arg);
            }
#line 2054 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 82:
#line 544 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.arg) = new Assignment((yyvsp[0].text));
                free((yyvsp[0].text));
            }
#line 2063 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 83:
#line 549 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.arg) = new Assignment((yyvsp[-2].text), boost::shared_ptr<Expression>((yyvsp[0].expr)));
                free((yyvsp[-2].text));
            }
#line 2072 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 84:
#line 557 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = new AssignmentList();
            }
#line 2080 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 85:
#line 561 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = new AssignmentList();
                (yyval.args)->push_back(*(yyvsp[0].arg));
                delete (yyvsp[0].arg);
            }
#line 2090 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 86:
#line 567 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = (yyvsp[-3].args);
                (yyval.args)->push_back(*(yyvsp[0].arg));
                delete (yyvsp[0].arg);
            }
#line 2100 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 87:
#line 576 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.arg) = new Assignment("", boost::shared_ptr<Expression>((yyvsp[0].expr)));
            }
#line 2108 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;

  case 88:
#line 580 "../src/parser.y" /* yacc.c:1646  */
    {
                (yyval.arg) = new Assignment((yyvsp[-2].text), boost::shared_ptr<Expression>((yyvsp[0].expr)));
                free((yyvsp[-2].text));
            }
#line 2117 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
    break;


#line 2121 "/home/don/builder/openscad/mingw64/tests-build/parser_yacc.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 586 "../src/parser.y" /* yacc.c:1906  */


int parserlex(void)
{
  return lexerlex();
}

void yyerror (char const *s)
{
  // FIXME: We leak memory on parser errors...
  PRINTB("Parser error in line %d: %s\n", lexerget_lineno() % s);
}

FileModule *parse(const char *text, const char *path, int debug)
{
  lexerin = NULL;
  parser_error_pos = -1;
  parser_input_buffer = text;
  parser_source_path = boosty::absolute(std::string(path)).string();

  rootmodule = new FileModule();
  rootmodule->setModulePath(path);
  scope_stack.push(&rootmodule->scope);
  //        PRINTB_NOCACHE("New module: %s %p", "root" % rootmodule);

  parserdebug = debug;
  int parserretval = parserparse();
  lexerdestroy();
  lexerlex_destroy();

  if (parserretval != 0) return NULL;

  parser_error_pos = -1;
  scope_stack.pop();
  return rootmodule;
}
